#tout vider
rm(list=ls())

#importation des donnes
setwd("D:/DataMining/Databases_for_mining/comparison_TOW/clustering_comparison")
voitures <- read.table(file="cars_dataset.txt",header=T,dec=".")
#description et statistiques descriptives
summary(voitures)

#prparer la fonction de standardisation d'une colonne
centrage_reduction <- function(x){
  return((x-mean(x))/sqrt(var(x)))
}
#appliquer pour produire le tableau des donnes centres et rduites
voitures.cr <- apply(voitures[,1:5],2,centrage_reduction)
#vrification
apply(voitures.cr,2,mean)
apply(voitures.cr,2,var)

#K-Means en 2 groupes
nb.classes <- 2
voitures.kmeans <- kmeans(voitures.cr,centers=nb.classes,iter.max=40)
print(voitures.kmeans)

#rcupration des groupes d'apparetenance
groupe <- as.factor(voitures.kmeans$cluster)
#calculer les barycentres des classes
#dans l'espace des variables actives initiales (numro 1  5)
centres <- NULL
for (k in 1:nb.classes){
  ligne <- colMeans(voitures[groupe==k,1:5,drop=FALSE])
  centres <- rbind(centres,ligne)
}
numero <- seq(from=1,to=nb.classes)
rownames(centres) <- paste("clus_",numero,sep="")
print(centres)

#croisement des clusters avec la variable illustrative catgorielle
print(table(voitures$origin,groupe))

#graphique des variables 2  2 avec groupe d'appaternance
pairs(voitures[,1:5],pch=21,bg=c("red","blue")[groupe])

#ACP sur les donnes centres rduites
acp <- princomp(voitures.cr,cor=T,scores=T)
print(acp)
#pour obtenir les valeurs propres
print(acp$sdev^2)
#pour obtenir les corrlations sur le premier axe
print(acp$loadings[,1]*acp$sdev[1])
#graphique dans le premier plan factoriel, avec mise en vidence des groupes
plot(acp$scores[,1],acp$scores[,2],type="p",pch=21,col=c("red","blue")[groupe])

#exportation des donnes avec le cluster d'appartenance
voitures.export <- cbind(voitures,groupe)
write.table(voitures.export,file="export_r.txt",sep="\t",dec=".",row.names=F)
